;secret stage boss
;www.sensenstahl.com
;fasm 1.69.31
;listening: soichi terada - purple haze

;this one was inspired by 2nd stage boss and final stage by 0x4015
;no one fucks with the secret stage boss!

;esc quits the intro. after the ship is gone it waits for esc letting the boss
;do his victory dance.

;it is NOT supposed to happen that the boss dies. while testing it happened a few times
;(out of a lot!)
;just to keep it save the intro will simply quit when the boss dies. you can feel happy!

;when the ship is drawn it is checked if the boss touched it. every pixel. so no hitbox ;)

;not much comments here. it was fun.


; 288b mouse control hack by wbcbz7 :)
; move mouse to move ship, LMB - fire, any keyboard button - exit
; try to kill it before it kills you! if it is too hard for you, add any character as command line parameter
; eg. 'boss.com A' will lengthen your lazer beam and 'boss.com z' will lengthen it even more! :D
; the higher ascii code - the longer your beam (not that you can thought xD)

; 309b gunshot sound added by Kuemmel on Hellmod's request ;-)

; 369b konami cheat code added by TomCat on Hardy's request ;-)

; sound for the boss

org 100h
use16

start:   push 0a000h
         pop es
         push 08000h
         pop fs
         mov al,13h
         int 10h
         ;xor ax, ax            ; for stupid mouse drivers
         ;int 0x33
         
        mov     bp, 256+128  ; bp = 384/0x180, we can use [bp+imm8] now for acessing consts ;)

		;---sound init by kuemmel
		pusha
		mov dx,0x331    	;init address also for tune play
		mov si,sound_init	;address of gunshot data
		outsb           	;change to UART mode
		dec dx          	;dec to data address
		mov cl,7        	;ch is zero
		rep outsb			;changes channel 0 to helicopter (=>boss) and channel 1 to gunshot sound
		popa
		;---sound init end
main:

mov byte[boss_expansion_value],0 ;by Kuemmel for boss sound volume adjust, init for every frame

xor si,si ;number of arms
          ;has to be this way and not set here maximum and below dec
          ;for correct access of data!

;in al,40h ;everything not needed
;xor ax,ax
;xor dx,dx
boss3:
;inc ax
;ch = always 0 here
mov cl,110;40 ;number of segments per element
mov di,320*86+180 ;base
boss2:
mov ch,byte[bp-384+start+15];80 ;size of segment
boss1:


add ax,cx ;calc movement
inc dx
mul dx
mov bx,ax
shr bx,12;12;13 ;0...3
shl bx,1  ;word
cmp bl,6  ;stay if outside of range
ja no
add di,word[ways+bx];grab movement value
no:

mov bl,39 ;base color ;save 1b with bl instead bx
cmp byte[fs:di+320*10+6],bl ;shadow works
jae neyney                  ;don't draw on tentacle
mov byte[fs:di+320*10+6],16
neyney:

add bx,si ;each tentacle has another color

mov byte[fs:di],bl ;draw boss

	;---draw bar for boss size start
	pusha
	mov ax,0xcccd			;rrrola's trick 
	mul di					;=> dh = y | dl = x (range x = 0...255 ; y = 0...199)
	sub dh,100
	jns no_neg_y
	  neg dh				;abs(y)	
	no_neg_y:
	sub dl,127
	jns no_neg_x
	  neg dl				;abs(x)
	no_neg_x:
	add dl,dh				;abs(x)+abs(y)
	shr dl,1
	cmp dl,byte[boss_expansion_value]
	jb no_save
	mov byte[boss_expansion_value],dl
	no_save:
	;---draw bar for boss size
	;movzx cx,dl
	;xor di,di
	;plot_loop:
	;   mov byte[fs:di+320*30],15
	;  inc di
	;loop plot_loop
	popa

dec ch
jnz boss1; segment done?


adc ax,word[bp-384+start]
loop boss2 ;all segments done?

cmp byte[bp-384+start+5],ch;0
jne noship ;if boss killed ship don't draw it

;ship
mov di,si
shl di,1

mov di,word[bp-384+data_pos+di] ;get data
add     di, word[bp-384+start+9]
mov cl,byte[bp-384+data_sze+si]
mov bl,byte[bp-384+data_col+si]
draw:
cmp byte[fs:di],39
;jae breaker        ;tentacle hit!
setae byte[bp-384+start+5] ;set if tentacle hit ship

mov byte[fs:di],bl ;draw ship
mov byte[fs:di+320*10+6],ch;0 ;shadow
inc di
loop draw

noship:
push    dx
push    ax
;slow it down for the cost of 8b
mov dx, 3dah
;vsync1:     ;not needed for this one
;in al,dx
;test al,8
;jnz vsync1
vsync2:
in al,dx
test al,8
jz vsync2
pop ax
pop dx

	;---boss volume change by Kuemmel
	pusha
	mov dx,0x330    		;address
	mov al,10110000b		;midi controller access
	out dx,al	
	mov al,7				;midi controller for volume				
	out dx,al
	mov al,byte[boss_expansion_value]	;get volume from MAX(x+y) from draw loop
	out dx,al
	popa
	;---boss volume change end

inc si
cmp si,4
jne boss3 ;do all tentacles

pusha

; get mouse pos
mov     ax, 0x3
int     0x33

imul    dx, 320
add     dx, cx
mov     word[bp-384+start+9], dx

test    bx, bx   ; button test
popa
jz      nonono  ; don't shoot!

cmp byte[bp-384+start+5],ch;0
jne nonono;no laser after death of ship
          ;nor movement of boss

in al,40h
xor al,bl     ;ah different every frame
jp nonono  ;no lazor

	;---sound for shot by Kuemmel
	pusha
	mov dx,0x330    	;address
	mov al,10010001b	;play note on channel 1
	out dx,al	
	mov al,60			;note
	out dx,al
	mov al,96			;volume...only 96 to make it not too loud compared to boss sound
	out dx,al
	popa
	;---sound for shot end
	
;dec byte[bp-384+start+2] ;there goes 1 pixel of the life bar
;jz breaker        ;it is not supposed to happen but
                  ;if the space cowboy wins the intro
                  ;just quits



mov  cl, [0x82] ; difficulty select via command line :D
add  cl, 20
laser:
cmp byte[fs:di],39 ;reached boss?
cmc
sbb bx, bx         ; fast bitmasking :)
add byte[bp-384+start+2], bl ;there goes 1 pixel of the life bar
jz breaker        ;it is not supposed to happen but
                  ;if the space cowboy wins the intro
                  ;just quits
sub word[bp-384+start+15],bx ;enlarge the boss, you space bitch

test bx, bx
jnz nonono
mov byte[fs:di],9 ;draw laser
inc di
loop laser         ;no so draw

nonono:

dec word[bp-384+start];global rnd seed

mov bx,320*4
bar:
mov cl,byte[bp-384+start+2];life of boss
lifebar:
imul di,cx,-1
mov byte[fs:bx+di+320*160-79],4
loop lifebar
sub bx,320
jnz bar

mov di,320*29 ;starting point of screen copy
mov bl,140    ;y
flip1:
mov cx,320    ;x
flip2:
mov ax,word[bp-384+start] ;do the bg
mul cx
sbb ax,di
shr ax,13
add al,16
xchg al,byte[fs:di]  ;drop to screen
stosb
loop flip2
dec bx
jnz flip1

;---konami cheat code mod by TomCat
 PUSHA
 PUSH   ES
 PUSH   BX
 POP    ES
.1:
 PUSH   BX
 MOV    CL,10
 MOV    SI,konami_code
.2:
 LEA    DI,[41EH+BX+1]
 CMPSB
 JNE    .3
 INC    BX
 INC    BX
 AND    BL,31
 LOOP   .2
 MOV    BYTE [82H],''
.3:
 POP    BX
 INC    BX
 INC    BX
 AND    BL,31
 JNZ    .1
 POP    ES
 POPA
;---konami cheat code mod end

         mov ah, 0x1
         int 0x16
         jz main              ;nothing so go on
 MOV    AH,0
 INT    16H
 CMP    AH,1
 JNE    main

breaker: ;ret
;ship data
data_pos dw 320*27+3,320*28+2,320*28+8,320*29+3 ;pos of element (+ hidden ret)
data_sze db 3        ,8        ,3        ,6         ;lenght of element
data_col db 15       ,7       ,2       ,15          ;color of element

;        0   2   4   6
ways dw 1,-320,-1,320   ;movements
sound_init db 0x3f				;chang to UART
		   db 11000000b,125		;change channel 0 to helicopter
		   db 11000001b,127		;change channel 1 to gunshot
		   db 10010000b,48,64	;play note channel 1
konami_code:
DB 48H,48H,50H,50H,4BH,4DH,4BH,4DH,30H,1EH
boss_expansion_value db ?
